package F5::Utils::Net;

use strict;
use warnings;

use F5::ASM::COAPI;
use Net::SSL ();
use IO::Socket::SSL;

sub get_proxy_settings {
    my $proxy;
    my $https_proxy_uri;
    my @db_vars = qw(proxy.host proxy.port proxy.username proxy.password proxy.protocol);
    for my $db_var (@db_vars) {
        my $query = F5::ASM::COAPI::Query->new("db_variable", { name => $db_var});
        if ($query && @$query) {
            my ($var) = @$query;
            ($proxy->{$db_var}) = $var->{value};
        }
    }
    if ($proxy->{'proxy.host'}) {
        $proxy->{'proxy.protocol'} ||= "http";
        $https_proxy_uri = "$proxy->{'proxy.protocol'}://" .
                                     $proxy->{'proxy.host'} .
                                     ($proxy->{'proxy.port'} ? ":$proxy->{'proxy.port'}" : "");
    }
    
    #reload  Net::HTTPS to use the neccessary SSL pacakge depending on if a proxy is being used
    my $ssl_socket_class = $https_proxy_uri ? 'Net::SSL' : 'IO::Socket::SSL';
    if (!$Net::HTTPS::SSL_SOCKET_CLASS || $Net::HTTPS::SSL_SOCKET_CLASS ne $ssl_socket_class) {
        $Net::HTTPS::SSL_SOCKET_CLASS = $ssl_socket_class;
        delete $INC{'Net/HTTPS.pm'};
        require Net::HTTPS;
    }
    return { proxy_uri => $https_proxy_uri,
             proxy_username => $proxy->{'proxy.username'},
             proxy_password => $proxy->{'proxy.password'},
           };
}


1;
